# This file is generated by scikitplot's build process
# It contains system_info results at the time of building this package.
from enum import Enum

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
  stdout = "stdout"
  dicts = "dicts"


def _cleanup(d):
  """
  Removes empty values in a `dict` recursively
  This ensures we remove values that Meson could not provide to CONFIG
  """
  if isinstance(d, dict):
    return { k: _cleanup(v) for k, v in d.items() if v != '' and _cleanup(v) != '' }
  else:
    return d


# Create a base CONFIG dictionary
CONFIG = _cleanup(
  {
    "Build Dependencies": {
      "blas": {
        "name": "scipy-openblas",
        "found": bool("True".lower().replace('false', '')),
        "version": "0.3.28",
        "detection method": "pkgconfig",
        "include directory": r"/private/var/folders/0w/4z5l9vds32nbkz7l22n8j6s80000gn/T/cibw-run-3dycabpg/cp313-macosx_arm64/build/venv/lib/python3.13/site-packages/scipy_openblas64/include",
        "lib directory": r"/private/var/folders/0w/4z5l9vds32nbkz7l22n8j6s80000gn/T/cibw-run-3dycabpg/cp313-macosx_arm64/build/venv/lib/python3.13/site-packages/scipy_openblas64/lib",
        "openblas configuration": r"OpenBLAS 0.3.28  USE64BITINT DYNAMIC_ARCH NO_AFFINITY neoversen1 MAX_THREADS=64",
        "pc file directory": r"/Users/runner/work/scikit-plots/scikit-plots/.openblas",
      },
      "lapack": {
        "name": "scipy-openblas",
        "found": bool("True".lower().replace('false', '')),
        "version": "0.3.28",
        "detection method": "pkgconfig",
        "include directory": r"/private/var/folders/0w/4z5l9vds32nbkz7l22n8j6s80000gn/T/cibw-run-3dycabpg/cp313-macosx_arm64/build/venv/lib/python3.13/site-packages/scipy_openblas64/include",
        "lib directory": r"/private/var/folders/0w/4z5l9vds32nbkz7l22n8j6s80000gn/T/cibw-run-3dycabpg/cp313-macosx_arm64/build/venv/lib/python3.13/site-packages/scipy_openblas64/lib",
        "openblas configuration": r"OpenBLAS 0.3.28  USE64BITINT DYNAMIC_ARCH NO_AFFINITY neoversen1 MAX_THREADS=64",
        "pc file directory": r"/Users/runner/work/scikit-plots/scikit-plots/.openblas",
      },
      "pybind11": {
        "name": "pybind11",
        "version": "2.13.6",
        "detection method": "config-tool",
        "include directory": r"unknown",
      },
    },
    "Compilers": {
      "fortran": {
        "name": "gcc",
        "linker": r"ld64",
        "version": "13.3.0",
        "commands": r"gfortran-13",
        "args": r"",
        "linker args": r"",
      },
      "c": {
        "name": "clang",
        "linker": r"ld64",
        "version": "15.0.0",
        "commands": r"cc",
        "args": r"",
        "linker args": r"",
      },
      "c++": {
        "name": "clang",
        "linker": r"ld64",
        "version": "15.0.0",
        "commands": r"c++",
        "args": r"",
        "linker args": r"",
      },
      "cython": {
        "name": r"cython",
        "linker": r"cython",
        "version": r"3.0.11",
        "commands": r"cython",
        "args": r"",
        "linker args": r"",
      },
      "pythran": {
        "version": r"",
        "include directory": r""
      },
    },
    "Machine Information": {
      "build": {
        "cpu": r"aarch64",
        "family": r"aarch64",
        "endian": r"little",
        "system": r"darwin",
      },
      "cross-compiled": bool("False".lower().replace('false', '')),
      "host": {
        "cpu": r"aarch64",
        "family": r"aarch64",
        "endian": r"little",
        "system": r"darwin",
      },
    },
    "Python Information": {
      "path": r"/private/var/folders/0w/4z5l9vds32nbkz7l22n8j6s80000gn/T/build-env-52rvl8lq/bin/python",
      "version": "3.13",
    },
  }
)


def _check_pyyaml():
  import yaml
  return yaml


def show(mode=DisplayModes.stdout.value):
  """
  Show libraries and system information on which SciPy was built
  and is being used

  Parameters
  ----------
  mode : {`'stdout'`, `'dicts'`}, optional.
      Indicates how to display the config information.
      `'stdout'` prints to console, `'dicts'` returns a dictionary
      of the configuration.

  Returns
  -------
  out : {`dict`, `None`}
      If mode is `'dicts'`, a dict is returned, else None

  Notes
  -----
  1. The `'stdout'` mode will give more readable
     output if ``pyyaml`` is installed
     
  Examples
  --------
  .. jupyter-execute::

      >>> import scikitplot
      >>> scikitplot.show_config()
  """
  if mode == DisplayModes.stdout.value:
      try:  # Non-standard library, check import
        yaml = _check_pyyaml()
        print(yaml.dump(CONFIG))
      except ModuleNotFoundError:
        import warnings
        import json

        warnings.warn("Install `pyyaml` for better output", stacklevel=1)
        print(json.dumps(CONFIG, indent=2))
  elif mode == DisplayModes.dicts.value:
    try:  # Non-standard library, check import
      from pprint import pprint
      pprint(CONFIG)
    except ModuleNotFoundError:
      return CONFIG
  else:
    raise AttributeError(
      f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
    )